SystemOrganization addCategory: #WaffleLayout!

Object subclass: #WFLength
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

WFLength subclass: #WFFixedLength
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFFixedLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:45'!
length

	^self number! !

!WFFixedLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:57'!
lengthIsFixed

	^true! !

!WFFixedLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:03'!
lengthIsProportional

	^false! !

!WFLength classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 09:21'!
number: aNumber

	^self new number: aNumber! !

!WFLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:44'!
defaultNumber

	^1! !

!WFLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:58'!
lengthIsFixed

	^false! !

!WFLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:43'!
number

	^number setDefault: #defaultNumber for: self  withSetter: #number:! !

!WFLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:43'!
number: aNumber

	number := aNumber! !

!WFLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:00'!
waffleSide: aWFWaffleSide 
! !

WFLength subclass: #WFProportionalLength
	instanceVariableNames: 'waffleSide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFProportionalLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 09:22'!
defaultWaffleSide

	|side|
	side :=  WFWaffleSide new.
	side addLength: self.    
	^side! !

!WFProportionalLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:12'!
length
	^ self proportion * self waffleSide absoluteLengthPerProportion! !

!WFProportionalLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:03'!
lengthIsProportional
	^true! !

!WFProportionalLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:47'!
proportion

	^self number! !

!WFProportionalLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:48'!
waffleSide

	^waffleSide setDefault: #defaultWaffleSide for: self withSetter: #waffleSide:! !

!WFProportionalLength methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:49'!
waffleSide: aWFWaffleSide 

	waffleSide := aWFWaffleSide! !

Object subclass: #WFWaffleLayout
	instanceVariableNames: 'rowLengths columnLengths'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:26'!
bounds

	^(self columnLengths range start @ self rowLengths range start) corner: (self columnLengths range stop @ self rowLengths range stop)! !

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:21'!
bounds: aRectangle 

	self rowLengths range: (Range close: aRectangle top open: aRectangle bottom).
	self columnLengths range: (Range close: aRectangle left open: aRectangle right).! !

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:32'!
boundsOfHoleAtRow: aSmallInteger atColumn: aSmallInteger2 

	|xRange yRange|
	xRange := self columnLengths rangeOfHoleAtIndex: aSmallInteger2.
	yRange := self rowLengths rangeOfHoleAtIndex: aSmallInteger.
	^(xRange start @ yRange start) corner: (xRange stop @ yRange stop)! !

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:24'!
columnLengths

	^ columnLengths setDefault: #defaultColumnLengths for: self  withSetter:  #columnLengths:! !

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:24'!
columnLengths: aWFWaffleSide 

	columnLengths := aWFWaffleSide! !

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:24'!
defaultColumnLengths

	^WFWaffleSide new! !

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:23'!
defaultRowLengths

	^WFWaffleSide new! !

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:22'!
rowLengths

	^ rowLengths setDefault: #defaultRowLengths for: self withSetter: #rowLengths:! !

!WFWaffleLayout methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:23'!
rowLengths: aWFWaffleSide 

	rowLengths := aWFWaffleSide! !

Object subclass: #WFWaffleSide
	instanceVariableNames: 'lengths range absoluteLengthPerProportion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:15'!
absoluteLengthPerProportion

	^absoluteLengthPerProportion setDefault: #defaultAbsoluteLengthPerProportion for: self withSetter: #absoluteLengthPerProportion:! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:15'!
absoluteLengthPerProportion: aFloat 

	absoluteLengthPerProportion := aFloat! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:15'!
addLength: aWFLength 
	
	self absoluteLengthPerProportion: nil.
	self lengths addLast: aWFLength.
	aWFLength waffleSide: self.  ! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:14'!
defaultAbsoluteLengthPerProportion
	
	^self lengthThatProportionalLengthsMayDivide / self sumOfProportions! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:55'!
defaultLengths

	^OrderedCollection new! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:51'!
defaultRange

	^Range close: 0 open: 100! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:57'!
fixedLengths

	^self lengths select: #lengthIsFixed! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:50'!
length

	^self range span! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:19'!
lengthOfHoleAtIndex: aSmallInteger 

	^self lengths at: aSmallInteger * 2! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:08'!
lengthThatProportionalLengthsMayDivide

	| result |
	result := self length - self sumOfFixedLengths.
	self assert: [result >= 0].  
	^result! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:55'!
lengths

	^ lengths setDefault: #defaultLengths for: self withSetter: #lengths:! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:55'!
lengths: anOrderedCollection 

	lengths := anOrderedCollection! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:03'!
proportionalLengths

	^self lengths select: #lengthIsProportional! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:51'!
range

	^range setDefault: #defaultRange for: self withSetter: #range:! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:15'!
range: aRange 

	self absoluteLengthPerProportion: nil.
	range := aRange! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 09:20'!
rangeOfHoleAtIndex: aSmallInteger 

	| rangeStart |
	rangeStart := (self range start + ((self lengths copyFrom: 1 to: (aSmallInteger * 2 - 1)) collect: #length) sum).
	^Range close: rangeStart open: (rangeStart + (self lengths at: aSmallInteger * 2) length).! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 09:23'!
sumOfFixedLengths
	
	| f |
	f := self fixedLengths collect: #length.
	^f isEmpty ifTrue: [0] ifFalse: [f sum].! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:02'!
sumOfProportions

	^(self proportionalLengths collect: #proportion) sum! !
